import { relToNode } from '../utils';
const createRel = (id, type = 'blood') => ({ id, type });
const createNode = (gender) => ({
    id: `${gender}-ph`,
    placeholder: true,
    gender: gender,
    parents: [],
    siblings: [],
    spouses: [],
    children: [],
});
const createParents = (store) => {
    const father = createNode('male');
    const mother = createNode('female');
    father.spouses = [createRel(mother.id, 'married')];
    mother.spouses = [createRel(father.id, 'married')];
    const { id, siblings } = store.root;
    return [father, mother].map(node => {
        node.children = siblings.concat(createRel(id));
        store.nodes.set(node.id, node);
        return createRel(node.id);
    });
};
const setParents = (parents) => {
    return (node) => node.parents = parents.slice();
};
export default (store) => {
    if (store.root.parents.length)
        return store;
    const setParentsTo = setParents(createParents(store));
    setParentsTo(store.root);
    store.root.siblings
        .map(relToNode(store))
        .forEach(setParentsTo);
    return store;
};
//# sourceMappingURL=placeholders.js.map