import Store from '../store';
import Unit from '../models/unit';
import { Gender, IFamilyNode, IRelation } from '../types';
export declare const prop: <T, K extends keyof T>(name: K) => (item: T) => T[K];
export declare const withId: <T extends {
    id: any;
}, K extends "id">(id: T[K]) => (item: T) => boolean;
export declare const withType: <T extends {
    type: string;
}>(...types: string[]) => (item: T) => boolean;
export declare const withSameIDs: (target: Unit) => (unit: Unit) => boolean;
export declare const flat: <T>(items: readonly T[], item: readonly T[]) => T[];
export declare const unique: <T>(item: T, index: number, arr: T[]) => boolean;
export declare const inAscOrder: (v1: number, v2: number) => number;
export declare const pipe: (...fus: Function[]) => <T>(init: T) => T;
export declare const relToNode: (store: Store) => (rel: IRelation) => IFamilyNode;
export declare const min: (arr: number[]) => number;
export declare const max: (arr: number[]) => number;
export declare function toMap<T extends {
    id: any;
}>(items: ReadonlyArray<T>): Map<T['id'], T>;
export declare function hasDiffParents(node: IFamilyNode): boolean;
export declare function byGender(target: Gender): (a: IFamilyNode, b: IFamilyNode) => 0 | -1;
